/* Unborg
   (c) 1997 FreeStone Systems, Roland Barmettler <roli@freestone.ch>
                               Matthias Cramer <cramer@freestone.ch>
   Originaly written in Borland Pascal 7.0 
   then converted to C by p2c and made some hand modifications.
   The p2c libraries and headerfiles are needed to compile this.
*/


#include <p2c/p2c.h>


typedef Char bytebit[8];


#define version         "0.1.2pl0"
#define compiled        "07-Nov-1997"


Static FILE *inf;
Static FILE *outf;
Static bytebit inv;
Static uchar outb, error;
Static long size, worked;
Static Char borg[5];
Static uchar z;
Static Char infile[256];
Static Char outfile[256];
Static Char inf_NAME[_FNSIZE];
Static Char outf_NAME[_FNSIZE];


Static Void usage()
{
  printf(" The Borg Compresser is a great nonsense product of two boys having\n");
  printf(" nothing better to do than something like this ... :-)\n\n");
  printf(" You can use this Expander with the following parameters:\n");
  printf("  -Ifilename   that's the file to compress with the extension .brg\n");
  printf("  -Ofilename   that's the outputfile\n");
  printf("  -?           to see this page ... (I think you have found that\n");
  printf("               out yourself by now :-) )\n\n");
  _Escape(1);
}



Static Void comandparam()
{
  uchar i;
  Char ch[2];
  Char STR1[256];
  Char STR2[256], STR3[256];

  if (P_argc == 1)
    usage();
  for (i = 1; i < P_argc; i++) {
    strsub(ch, strcpy(STR2, P_argv[i]), 2, 1);
    switch (toupper(ch[0])) {

    case 'I':
      strsub(infile, strcpy(STR1, P_argv[i]), 3,
	     (int)(strlen(strcpy(STR3, P_argv[i])) - 2));
      break;

    case 'O':
      strsub(outfile, strcpy(STR3, P_argv[i]), 3,
	     (int)(strlen(strcpy(STR2, P_argv[i])) - 2));
      break;

    case '?':
      usage();
      break;
    }
  }
}


Static Void setbit(position, changebyte)
uchar position, *changebyte;
{
  /* Set a Bit at Position <0-7> to Value */
  uchar wd;

  wd = 0x1;
  wd <<= position;
  *changebyte |= wd;
}


Static uchar bit2byte(b)
Char *b;
{
  uchar i, hilf;

  hilf = 0;
  for (i = 0; i <= 7; i++) {
    if ((b[i] & (~127)) != 0)
      setbit(i, &hilf);
  }
  return hilf;
}


main(argc, argv)
int argc;
Char *argv[];
{
  Char STR1[256];

  PASCAL_MAIN(argc, argv);
  outf = NULL;
  inf = NULL;
  printf(" UnBorger for Linux, the ultimative file compresser %s\n", version);
  printf(" Compiled in a bad minute on %s by\n", compiled);
  printf(" Roland Barmettler & Matthias Cramer\n");
  printf(" cramer@freestone.ch\n");
  comandparam();
  putchar('\n');
  strcpy(inf_NAME, infile);
  strcpy(outf_NAME, outfile);
  if (inf != NULL)
    inf = freopen(inf_NAME, "r+b", inf);
  else
    inf = fopen(inf_NAME, "r+b");
  _SETIO(inf != NULL, FileNotFound);
  error = P_ioresult;
  switch (error) {

  case 2:
    printf(" The file %s does not exist !\007\n", infile);
    _Escape(9);
    break;

  case 5:
    printf(" The file %s is write-protected !!\007\n", infile);
    _Escape(9);
    break;
  }
  if (outf != NULL)
    outf = freopen(outf_NAME, "w+b", outf);
  else
    outf = fopen(outf_NAME, "w+b");
  if (outf == NULL)
    _EscIO(FileNotFound);
  size = P_maxpos(inf) / sizeof(bytebit) + 1;
  *borg = '\0';
  for (z = 1; z <= 4; z++) {
    if (!P_eof(inf)) {
      fread(inv, sizeof(bytebit), 1, inf);
      outb = bit2byte(inv);
      sprintf(borg + strlen(borg), "%c", outb);
    }
  }
  if (strcmp(borg, "Borg") ||
      strcmp(strsub(STR1, infile, strpos2(infile, ".", 1), strlen(infile)),
	     ".brg")) {
    printf(" The file %s is not a Borg expanded file !!\n", infile);
    printf(" SysTem halted ... \007\n");
    _Escape(255);
  }
  worked = 4;
  while (!P_eof(inf)) {
    fread(inv, sizeof(bytebit), 1, inf);
    outb = bit2byte(inv);
    worked++;
    printf("\015Compressing : %ld %%  ", worked * 100 / size);
    fwrite(&outb, sizeof(uchar), 1, outf);
  }
  if (inf != NULL)
    fclose(inf);
  inf = NULL;
  if (outf != NULL)
    fclose(outf);
  outf = NULL;
  if (inf != NULL)
    fclose(inf);
  if (outf != NULL)
    fclose(outf);
  exit(EXIT_SUCCESS);
}



